package unearthables;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Animation;
import com.badlogic.gdx.graphics.g2d.Animation.PlayMode;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.utils.Array;
import com.ld57.game.ddd;

public class Sapphire extends Sprite {// this is a very simple, non animated sprite. Is this the lightest thing I have?
	public enum State {
		MAIN, ON
	};

	public State currentState;
	public State previousState;
	private Animation<TextureRegion> on;
	private float _stateTimer;
	private boolean isAnimationOver;
	private TextureRegion main;
	private Texture t1;
	public Color color;
	public Rectangle rect;
	private int _sw;// sprite width
	private int _sh;// sprite height
	public boolean isDead;
	private float timer = .02f;
	private float angle = 1f;
	private float angleSpeed = .01f;
	private float widthX;
	private float heightY;
	private float speed;
	private float originX;
	private float originY;
	private float originSpeed;
	private float ovalIncreaserX;
	private float originOvalIncreaserX;
	private float ovalIncreaserY;
	private float originOvalIncreaserY;

	public Sapphire(float _x, float _y) {
		rect = new Rectangle();
		rect.x = (int) _x;
		rect.y = (int) _y;
		rect.width = 15;
		rect.height = 15;
		_sw = 15;
		_sh = 15;
		// still frames
		t1 = new Texture(Gdx.files.internal("sapphire.png"));
		main = new TextureRegion(t1, (0 * _sw), (0 * _sh), _sw, _sh);
		// animated frames
		Array<TextureRegion> frames = new Array<TextureRegion>();
		frames.add(new TextureRegion(t1, (0 * _sw), (0 * _sh), _sw, _sh));
		frames.add(new TextureRegion(t1, (1 * _sw), (0 * _sh), _sw, _sh));
		frames.add(new TextureRegion(t1, (2 * _sw), (0 * _sh), _sw, _sh));
		frames.add(new TextureRegion(t1, (1 * _sw), (0 * _sh), _sw, _sh));
		on = new Animation<TextureRegion>(MathUtils.random(.1f, .4f), frames, PlayMode.LOOP);
		frames.clear();
		color = Color.WHITE;
		setBounds(0, 0, _sw, _sh);
		setOriginCenter();
		setRegion(main);
		originX = widthX = MathUtils.random(300f, 350f);
		originY = heightY = MathUtils.random(300f, 340f);
		originSpeed = speed = MathUtils.random(.1f, .4f);
		angle = MathUtils.random(1f, 360f);
		originOvalIncreaserX = ovalIncreaserX = MathUtils.random(1.2f, 1.5f);
		originOvalIncreaserY = ovalIncreaserY = MathUtils.random(1.2f, 1.5f);
	}

	private void Update() {
		rect.x = timer + widthX + 250 * MathUtils.cos(angle) * ovalIncreaserX;
		rect.y = timer + heightY + 200 * MathUtils.sin(angle) * ovalIncreaserY;
		angle += angleSpeed;
		if (angle >= 360)
			angle = 1;
		timer += speed;
		if (angleSpeed < .01f)
			angleSpeed += .02f;
		if (ovalIncreaserX < 5.0f)
			ovalIncreaserX += .02f;
		if (ovalIncreaserY < 5.0f)
			ovalIncreaserY += .05f;

		if (rect.x < -206 | rect.x > ddd.MW | rect.y < -206 | rect.y > ddd.MH) {
			widthX = originX;
			heightY = originY;
			speed = originSpeed;
			ovalIncreaserX = originOvalIncreaserX;
			ovalIncreaserY = originOvalIncreaserY;
			timer = 0;
			angleSpeed = .01f;
		}
	}

	public TextureRegion getFrame(OrthographicCamera camera, float dt) {
		Update();
		currentState = getState();

		TextureRegion region;
		switch (currentState) {
		case ON:
			region = on.getKeyFrame(_stateTimer, true);
			break;
		case MAIN:
			region = main;
			break;
		default:
			region = on.getKeyFrame(_stateTimer, true);
			break;
		}
		if (currentState != previousState)
			isAnimationOver = false;

		if (!isAnimationOver && currentState == previousState) {
			_stateTimer += dt;
		} else
			_stateTimer = 0;
		// System.out.println("statetimer: " + _stateTimer);
		previousState = currentState;

		return region;
	}

	public State getState() {
		return State.ON;
	}

	public void render(ddd game, OrthographicCamera camera, float dt) {// hmmm i think it just needs placed before? it gets here.
		game.batch.setColor(color);
		game.batch.draw(getFrame(camera, dt), rect.x, rect.y);
	}

	public void dispose() {
	}
}
